using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Data;
using System.Collections.Generic;
using System.Collections.Specialized;
using AjaxControlToolkit;
using JobSiteStarterKit.DAL;
using JobSiteStarterKit.BOL;


/// <summary>
/// Summary description for LocationService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.Web.Script.Services.ScriptService()]
public class LocationService : System.Web.Services.WebService
{

    [WebMethod]
    public CascadingDropDownNameValue[] GetCountries(string knownCategoryValues, string category)
    {
        List<CascadingDropDownNameValue> countryList = new List<CascadingDropDownNameValue>();

        DataSet dsCountry = Country.GetCountries();
        foreach (DataRow row in dsCountry.Tables[0].Rows)
        {
            countryList.Add(new CascadingDropDownNameValue(row["CountryName"].ToString(), row["CountryID"].ToString()));
        }

        return countryList.ToArray();
    }

    [WebMethod]
    public CascadingDropDownNameValue[] GetStatesForCountry(string knownCategoryValues, string category)
    {
        StringDictionary kv = CascadingDropDown.ParseKnownCategoryValuesString(knownCategoryValues);

        List<CascadingDropDownNameValue> stateList = new List<CascadingDropDownNameValue>();

        DataSet dsState = State.GetStates(int.Parse(kv["Country"]));
        foreach (DataRow row in dsState.Tables[0].Rows)
        {
            stateList.Add(new CascadingDropDownNameValue(row["StateName"].ToString(), row["StateID"].ToString()));
        }

        return stateList.ToArray();
    }

}

